3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # if --tee was passed, write the output not only to the terminal, but
19 # additionally to the file test-results/$BASENAME.out, too.
20 case "$GIT_TEST_TEE_STARTED, $* " in
22 # do not redirect again
24 *' --tee '*|
*' --va'*)
26 BASE
=test-results
/$
(basename "$0" .sh
)
27 (GIT_TEST_TEE_STARTED
=done ${SHELL-sh} "$0" "$@" 2>&1;
28 echo $?
> $BASE.
exit) |
tee $BASE.out
29 test "$(cat $BASE.exit)" = 0
34 # Keep the original TERM for say_color
37 # For repeatability, reset the environment to known value.
43 export LANG LC_ALL PAGER TERM TZ
50 unset COMMIT_AUTHOR_EMAIL
51 unset COMMIT_AUTHOR_NAME
53 unset GIT_ALTERNATE_OBJECT_DIRECTORIES
55 GIT_AUTHOR_EMAIL
=author@example.com
56 GIT_AUTHOR_NAME
='A U Thor'
57 unset GIT_COMMITTER_DATE
58 GIT_COMMITTER_EMAIL
=committer@example.com
59 GIT_COMMITTER_NAME
='C O Mitter'
63 unset GIT_EXTERNAL_DIFF
65 unset GIT_OBJECT_DIRECTORY
66 unset GIT_CEILING_DIRECTORIES
67 unset SHA1_FILE_DIRECTORIES
68 unset SHA1_FILE_DIRECTORY
70 unset GIT_NOTES_DISPLAY_REF
71 unset GIT_NOTES_REWRITE_REF
72 unset GIT_NOTES_REWRITE_MODE
73 unset GIT_REFLOG_ACTION
74 unset GIT_CHERRY_PICK_HELP
77 export GIT_MERGE_VERBOSITY
78 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
79 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
82 # Protect ourselves from common misconfiguration to export
83 # CDPATH into the environment
88 case $
(echo $GIT_TRACE |
tr "[A-Z]" "[a-z]") in
90 echo "* warning: Some tests will not work if GIT_TRACE" \
91 "is set as to trace on STDERR ! *"
92 echo "* warning: Please set GIT_TRACE to something" \
93 "other than 1, 2 or true ! *"
99 # A regexp to match 5 and 40 hexdigits
100 _x05
='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
101 _x40
="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
103 # Each test should start with something like this, after copyright notices:
105 # test_description='Description of this test...
106 # This test checks if command xyzzy does the right thing...
109 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
110 TERM
=$ORIGINAL_TERM &&
113 tput bold
>/dev
/null
2>&1 &&
114 tput setaf
1 >/dev
/null
2>&1 &&
115 tput sgr0
>/dev
/null
2>&1
119 while test "$#" -ne 0
122 -d|
--d|
--de|
--deb|
--debu|
--debug)
124 -i|
--i|
--im|
--imm|
--imme|
--immed|
--immedi|
--immedia|
--immediat|
--immediate)
125 immediate
=t
; shift ;;
126 -l|
--l|
--lo|
--lon|
--long|
--long-|
--long-t|
--long-te|
--long-tes|
--long-test|
--long-tests)
127 GIT_TEST_LONG
=t
; export GIT_TEST_LONG
; shift ;;
128 -h|
--h|
--he|
--hel|
--help)
130 -v|
--v|
--ve|
--ver|
--verb|
--verbo|
--verbos|
--verbose)
132 -q|
--q|
--qu|
--qui|
--quie|
--quiet)
133 # Ignore --quiet under a TAP::Harness. Saying how many tests
134 # passed without the ok/not ok details is always an error.
135 test -z "$HARNESS_ACTIVE" && quiet
=t
; shift ;;
137 with_dashes
=t
; shift ;;
140 --va|
--val|
--valg|
--valgr|
--valgri|
--valgrin|
--valgrind)
141 valgrind
=t
; verbose
=t
; shift ;;
143 shift ;; # was handled already
145 root
=$
(expr "z$1" : 'z[^=]*=\(.*\)')
148 echo "error: unknown test option '$1'" >&2; exit 1 ;;
152 if test -n "$color"; then
158 error
) tput bold
; tput setaf
1;; # bold red
159 skip
) tput bold
; tput setaf
2;; # bold green
160 pass
) tput setaf
2;; # green
161 info
) tput setaf
3;; # brown
162 *) test -n "$quiet" && return;;
172 test -z "$1" && test -n "$quiet" && return
179 say_color error
"error: $*"
188 test "${test_description}" != "" ||
189 error
"Test script did not set test_description."
191 if test "$help" = "t"
193 echo "$test_description"
198 if test "$verbose" = "t"
202 exec 4>/dev
/null
3>/dev
/null
211 test_external_has_tap
=0
215 if test -n "$GIT_EXIT_OK"
219 echo >&5 "FATAL: Unexpected exit with code $code"
227 # The semantics of the editor variables are that of invoking
228 # sh -c "$EDITOR \"$@\"" files ...
230 # If our trash directory contains shell metacharacters, they will be
231 # interpreted if we just set $EDITOR directly, so do a little dance with
232 # environment variables to work around this.
234 # In particular, quoting isn't enough, as the path may contain the same quote
239 EDITOR
='"$FAKE_EDITOR"'
243 test_decode_color
() {
246 if (n == 0) return "RESET";
247 if (n == 1) return "BOLD";
248 if (n == 30) return "BLACK";
249 if (n == 31) return "RED";
250 if (n == 32) return "GREEN";
251 if (n == 33) return "YELLOW";
252 if (n == 34) return "BLUE";
253 if (n == 35) return "MAGENTA";
254 if (n == 36) return "CYAN";
255 if (n == 37) return "WHITE";
256 if (n == 40) return "BLACK";
257 if (n == 41) return "BRED";
258 if (n == 42) return "BGREEN";
259 if (n == 43) return "BYELLOW";
260 if (n == 44) return "BBLUE";
261 if (n == 45) return "BMAGENTA";
262 if (n == 46) return "BCYAN";
263 if (n == 47) return "BWHITE";
266 while (match($0, /\033\[[0-9;]*m/) != 0) {
267 printf "%s<", substr($0, 1, RSTART-1);
268 codes = substr($0, RSTART+2, RLENGTH-3);
269 if (length(codes) == 0)
272 n = split(codes, ary, ";");
274 for (i = 1; i <= n; i++) {
275 printf "%s%s", sep, name(ary[i]);
280 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
304 sed -e 's/$/Q/' |
tr Q
'\015'
308 tr '\015' Q |
sed -e 's/Q$//'
311 # In some bourne shell implementations, the "unset" builtin returns
312 # nonzero status when a variable to be unset was not set in the first
315 # Use sane_unset when that should not be considered an error.
323 if test -z "${test_tick+set}"
327 test_tick
=$
(($test_tick + 60))
329 GIT_COMMITTER_DATE
="$test_tick -0700"
330 GIT_AUTHOR_DATE
="$test_tick -0700"
331 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
334 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
336 # This will commit a file with the given contents and the given commit
337 # message. It will also add a tag with <message> as name.
339 # Both <file> and <contents> default to <message>.
343 echo "${3-$1}" > "$file" &&
346 git commit
-m "$1" &&
350 # Call test_merge with the arguments "<message> <commit>", where <commit>
351 # can be a tag pointing to the commit-to-merge.
355 git merge
-m "$1" "$2" &&
359 # This function helps systems where core.filemode=false is set.
360 # Use it instead of plain 'chmod +x' to set or unset the executable bit
361 # of a file in the working directory and add it to the index.
365 git update-index
--add "--chmod=$@"
368 # Use test_set_prereq to tell that a particular prerequisite is available.
369 # The prerequisite can later be checked for in two ways:
371 # - Explicitly using test_have_prereq.
373 # - Implicitly by specifying the prerequisite tag in the calls to
374 # test_expect_{success,failure,code}.
376 # The single parameter is the prerequisite tag (a simple word, in all
377 # capital letters by convention).
380 satisfied
="$satisfied$1 "
384 test_have_prereq
() {
385 # prerequisites can be concatenated with ','
397 total_prereq
=$
(($total_prereq + 1))
400 ok_prereq
=$
(($ok_prereq + 1))
403 # Keep a list of missing prerequisites
404 if test -z "$missing_prereq"
406 missing_prereq
=$prerequisite
408 missing_prereq
="$prerequisite,$missing_prereq"
413 test $total_prereq = $ok_prereq
416 test_declared_prereq
() {
417 case ",$test_prereq," in
425 # You are not expected to call test_ok_ and test_failure_ directly, use
426 # the text_expect_* functions instead.
429 test_success
=$
(($test_success + 1))
430 say_color
"" "ok $test_count - $@"
434 test_failure
=$
(($test_failure + 1))
435 say_color error
"not ok - $test_count $1"
437 echo "$@" |
sed -e 's/^/# /'
438 test "$immediate" = "" ||
{ GIT_EXIT_OK
=t
; exit 1; }
441 test_known_broken_ok_
() {
442 test_fixed
=$
(($test_fixed+1))
443 say_color
"" "ok $test_count - $@ # TODO known breakage"
446 test_known_broken_failure_
() {
447 test_broken
=$
(($test_broken+1))
448 say_color skip
"not ok $test_count - $@ # TODO known breakage"
452 test "$debug" = "" ||
eval "$1"
459 eval >&3 2>&4 "$test_cleanup"
460 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
467 test_count
=$
(($test_count+1))
469 for skp
in $GIT_SKIP_TESTS
471 case $this_test.
$test_count in
477 if test -z "$to_skip" && test -n "$test_prereq" &&
478 ! test_have_prereq
"$test_prereq"
485 if test "$missing_prereq" != "$test_prereq"
487 of_prereq
=" of $test_prereq"
490 say_color skip
>&3 "skipping test: $@"
491 say_color skip
"ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
500 test_expect_failure
() {
501 test "$#" = 3 && { test_prereq
=$1; shift; } || test_prereq
=
503 error
"bug in the test script: not 2 or 3 parameters to test-expect-failure"
507 say
>&3 "checking known breakage: $2"
509 if [ "$?" = 0 -a "$eval_ret" = 0 ]
511 test_known_broken_ok_
"$1"
513 test_known_broken_failure_
"$1"
519 test_expect_success
() {
520 test "$#" = 3 && { test_prereq
=$1; shift; } || test_prereq
=
522 error
"bug in the test script: not 2 or 3 parameters to test-expect-success"
526 say
>&3 "expecting success: $2"
528 if [ "$?" = 0 -a "$eval_ret" = 0 ]
538 # test_external runs external test scripts that provide continuous
539 # test output about their progress, and succeeds/fails on
540 # zero/non-zero exit code. It outputs the test output on stdout even
541 # in non-verbose mode, and announces the external script with "# run
542 # <n>: ..." before running it. When providing relative paths, keep in
543 # mind that all scripts run in "trash directory".
544 # Usage: test_external description command arguments...
545 # Example: test_external 'Perl API' perl ../path/to/test.pl
547 test "$#" = 4 && { test_prereq
=$1; shift; } || test_prereq
=
549 error
>&5 "bug in the test script: not 3 or 4 parameters to test_external"
553 if ! test_skip
"$descr" "$@"
555 # Announce the script to reduce confusion about the
556 # test output that follows.
557 say_color
"" "# run $test_count: $descr ($*)"
558 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
559 # to be able to use them in script
560 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
561 # Run command; redirect its stderr to &4 as in
562 # test_run_, but keep its stdout on our stdout even in
567 if test $test_external_has_tap -eq 0; then
570 say_color
"" "# test_external test $descr was ok"
571 test_success
=$
(($test_success + 1))
574 if test $test_external_has_tap -eq 0; then
575 test_failure_
"$descr" "$@"
577 say_color error
"# test_external test $descr failed: $@"
578 test_failure
=$
(($test_failure + 1))
584 # Like test_external, but in addition tests that the command generated
585 # no output on stderr.
586 test_external_without_stderr
() {
587 # The temporary file has no (and must have no) security
589 tmp
="$TMPDIR"; if [ -z "$tmp" ]; then tmp
=/tmp
; fi
590 stderr
="$tmp/git-external-stderr.$$.tmp"
591 test_external
"$@" 4> "$stderr"
592 [ -f "$stderr" ] || error
"Internal error: $stderr disappeared."
593 descr
="no stderr: $1"
595 say
>&3 "# expecting no stderr from previous command"
596 if [ ! -s "$stderr" ]; then
599 if test $test_external_has_tap -eq 0; then
602 say_color
"" "# test_external_without_stderr test $descr was ok"
603 test_success
=$
(($test_success + 1))
606 if [ "$verbose" = t
]; then
607 output
=`echo; echo "# Stderr is:"; cat "$stderr"`
611 # rm first in case test_failure exits.
613 if test $test_external_has_tap -eq 0; then
614 test_failure_
"$descr" "$@" "$output"
616 say_color error
"# test_external_without_stderr test $descr failed: $@: $output"
617 test_failure
=$
(($test_failure + 1))
622 # debugging-friendly alternatives to "test [-f|-d|-e]"
623 # The commands test the existence or non-existence of $1. $2 can be
624 # given to provide a more precise diagnosis.
625 test_path_is_file
() {
628 echo "File $1 doesn't exist. $*"
633 test_path_is_dir
() {
636 echo "Directory $1 doesn't exist. $*"
641 test_path_is_missing
() {
646 if [ $# -ge 1 ]; then
653 # test_line_count checks that a file has the number of lines it
654 # ought to. For example:
656 # test_expect_success 'produce exactly one line of output' '
657 # do something >output &&
658 # test_line_count = 1 output
661 # is like "test $(wc -l <output) = 1" except that it passes the
662 # output through when the number of lines is wrong.
667 error
"bug in the test script: not 3 parameters to test_line_count"
668 elif ! test $
(wc -l <"$3") "$1" "$2"
670 echo "test_line_count: line count for $3 !$1 $2"
676 # This is not among top-level (test_expect_success | test_expect_failure)
677 # but is a prefix that can be used in the test script, like:
679 # test_expect_success 'complain and die' '
681 # do something else &&
682 # test_must_fail git checkout ../outerspace
685 # Writing this as "! git checkout ../outerspace" is wrong, because
686 # the failure could be due to a segv. We want a controlled failure.
691 if test $exit_code = 0; then
692 echo >&2 "test_must_fail: command succeeded: $*"
694 elif test $exit_code -gt 129 -a $exit_code -le 192; then
695 echo >&2 "test_must_fail: died by signal: $*"
697 elif test $exit_code = 127; then
698 echo >&2 "test_must_fail: command not found: $*"
704 # Similar to test_must_fail, but tolerates success, too. This is
705 # meant to be used in contexts like:
707 # test_expect_success 'some command works without configuration' '
708 # test_might_fail git config --unset all.configuration &&
712 # Writing "git config --unset all.configuration || :" would be wrong,
713 # because we want to notice if it fails due to segv.
718 if test $exit_code -gt 129 -a $exit_code -le 192; then
719 echo >&2 "test_might_fail: died by signal: $*"
721 elif test $exit_code = 127; then
722 echo >&2 "test_might_fail: command not found: $*"
728 # Similar to test_must_fail and test_might_fail, but check that a
729 # given command exited with a given exit code. Meant to be used as:
731 # test_expect_success 'Merge with d/f conflicts' '
732 # test_expect_code 1 git merge "merge msg" B master
735 test_expect_code
() {
740 if test $exit_code = $want_code
742 echo >&2 "test_expect_code: command exited with $exit_code: $*"
745 echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
750 # test_cmp is a helper function to compare actual and expected output.
751 # You can use it like:
753 # test_expect_success 'foo works' '
754 # echo expected >expected &&
756 # test_cmp expected actual
759 # This could be written as either "cmp" or "diff -u", but:
760 # - cmp's output is not nearly as easy to read as diff -u
761 # - not all diff versions understand "-u"
767 # This function can be used to schedule some commands to be run
768 # unconditionally at the end of the test to restore sanity:
770 # test_expect_success 'test core.capslock' '
771 # git config core.capslock true &&
772 # test_when_finished "git config --unset core.capslock" &&
776 # That would be roughly equivalent to
778 # test_expect_success 'test core.capslock' '
779 # git config core.capslock true &&
781 # git config --unset core.capslock
784 # except that the greeting and config --unset must both succeed for
787 test_when_finished
() {
789 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
792 # Most tests can use the created repository, but some may need to create more.
793 # Usage: test_create_repo <directory>
794 test_create_repo
() {
796 error
"bug in the test script: not 1 parameter to test-create-repo"
800 cd "$repo" || error
"Cannot setup test environment"
801 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
802 error
"cannot run git init -- have you built things yet?"
803 mv .git
/hooks .git
/hooks-disabled
810 if test -z "$HARNESS_ACTIVE"; then
811 test_results_dir
="$TEST_DIRECTORY/test-results"
812 mkdir
-p "$test_results_dir"
813 test_results_path
="$test_results_dir/${0%.sh}-$$.counts"
815 echo "total $test_count" >> $test_results_path
816 echo "success $test_success" >> $test_results_path
817 echo "fixed $test_fixed" >> $test_results_path
818 echo "broken $test_broken" >> $test_results_path
819 echo "failed $test_failure" >> $test_results_path
820 echo "" >> $test_results_path
823 if test "$test_fixed" != 0
825 say_color pass
"# fixed $test_fixed known breakage(s)"
827 if test "$test_broken" != 0
829 say_color error
"# still have $test_broken known breakage(s)"
830 msg
="remaining $(($test_count-$test_broken)) test(s)"
832 msg
="$test_count test(s)"
834 case "$test_failure" in
836 # Maybe print SKIP message
837 [ -z "$skip_all" ] || skip_all
=" # SKIP $skip_all"
839 if test $test_external_has_tap -eq 0; then
840 say_color pass
"# passed all $msg"
841 say
"1..$test_count$skip_all"
844 test -d "$remove_trash" &&
845 cd "$(dirname "$remove_trash")" &&
846 rm -rf "$(basename "$remove_trash")"
851 if test $test_external_has_tap -eq 0; then
852 say_color error
"# failed $test_failure among $msg"
861 # Test the binaries we have just built. The tests are kept in
862 # t/ subdirectory and are run in 'trash directory' subdirectory.
863 if test -z "$TEST_DIRECTORY"
865 # We allow tests to override this, in case they want to run tests
866 # outside of t/, e.g. for running tests on the test library
868 TEST_DIRECTORY
=$
(pwd)
870 GIT_BUILD_DIR
="$TEST_DIRECTORY"/..
872 if test -n "$valgrind"
876 test "$1" = "$(readlink "$2")" ||
{
884 while test -d "$2".lock
886 say
"Waiting for lock on $2."
893 make_valgrind_symlink
() {
894 # handle only executables
895 test -x "$1" ||
return
897 base
=$
(basename "$1")
898 symlink_target
=$GIT_BUILD_DIR/$base
899 # do not override scripts
900 if test -x "$symlink_target" &&
901 test ! -d "$symlink_target" &&
902 test "#!" != "$(head -c 2 < "$symlink_target")"
904 symlink_target
=..
/valgrind.sh
908 symlink_target
=..
/unprocessed-script
910 # create the link, or replace it if it is out of date
911 make_symlink
"$symlink_target" "$GIT_VALGRIND/bin/$base" ||
exit
914 # override all git executables in TEST_DIRECTORY/..
915 GIT_VALGRIND
=$TEST_DIRECTORY/valgrind
916 mkdir
-p "$GIT_VALGRIND"/bin
917 for file in $GIT_BUILD_DIR/git
* $GIT_BUILD_DIR/test-
*
919 make_valgrind_symlink
$file
925 ls "$path"/git-
* 2> /dev
/null |
928 make_valgrind_symlink
"$file"
932 PATH
=$GIT_VALGRIND/bin
:$PATH
933 GIT_EXEC_PATH
=$GIT_VALGRIND/bin
935 elif test -n "$GIT_TEST_INSTALLED" ; then
936 GIT_EXEC_PATH
=$
($GIT_TEST_INSTALLED/git
--exec-path) ||
937 error
"Cannot run git from $GIT_TEST_INSTALLED."
938 PATH
=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
939 GIT_EXEC_PATH
=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
940 else # normal case, use ../bin-wrappers only unless $with_dashes:
941 git_bin_dir
="$GIT_BUILD_DIR/bin-wrappers"
942 if ! test -x "$git_bin_dir/git" ; then
943 if test -z "$with_dashes" ; then
944 say
"$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
948 PATH
="$git_bin_dir:$PATH"
949 GIT_EXEC_PATH
=$GIT_BUILD_DIR
950 if test -n "$with_dashes" ; then
951 PATH
="$GIT_BUILD_DIR:$PATH"
954 GIT_TEMPLATE_DIR
="$GIT_BUILD_DIR"/templates
/blt
956 GIT_CONFIG_NOSYSTEM
=1
957 GIT_CONFIG_NOGLOBAL
=1
958 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
960 .
"$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
962 if test -z "$GIT_TEST_CMP"
964 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
966 GIT_TEST_CMP
="$DIFF -c"
968 GIT_TEST_CMP
="$DIFF -u"
972 GITPERLLIB
="$GIT_BUILD_DIR"/perl
/blib
/lib
:"$GIT_BUILD_DIR"/perl
/blib
/arch
/auto
/Git
974 test -d "$GIT_BUILD_DIR"/templates
/blt ||
{
975 error
"You haven't built things yet, have you?"
978 if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
980 GITPYTHONLIB
="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
982 test -d "$GIT_BUILD_DIR"/git_remote_helpers
/build ||
{
983 error
"You haven't built git_remote_helpers yet, have you?"
987 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
; then
988 echo >&2 'You need to build test-chmtime:'
989 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
994 test="trash directory.$(basename "$0" .sh)"
995 test -n "$root" && test="$root/$test"
997 /*) TRASH_DIRECTORY
="$test" ;;
998 *) TRASH_DIRECTORY
="$TEST_DIRECTORY/$test" ;;
1000 test ! -z "$debug" || remove_trash
=$TRASH_DIRECTORY
1003 echo >&5 "FATAL: Cannot prepare test area"
1007 test_create_repo
"$test"
1008 # Use -P to resolve symlinks in our working directory so that the cwd
1009 # in subprocesses like git equals our $PWD (for pathname comparisons).
1010 cd -P "$test" ||
exit 1
1016 this_test
=${this_test%%-*}
1017 for skp
in $GIT_SKIP_TESTS
1019 case "$this_test" in
1021 say_color skip
>&3 "skipping test $this_test altogether"
1022 skip_all
="skip all tests in $this_test"
1027 # Provide an implementation of the 'yes' utility
1042 # Fix some commands on Windows
1045 # Windows has its own (incompatible) sort and find
1055 # git sees Windows-style pwd
1059 # no POSIX permissions
1060 # backslashes in pathspec are converted to '/'
1061 # exec does not inherit the PID
1062 test_set_prereq MINGW
1063 test_set_prereq SED_STRIPS_CR
1066 test_set_prereq POSIXPERM
1067 test_set_prereq EXECKEEPSPID
1068 test_set_prereq NOT_MINGW
1069 test_set_prereq SED_STRIPS_CR
1072 test_set_prereq POSIXPERM
1073 test_set_prereq BSLASHPSPEC
1074 test_set_prereq EXECKEEPSPID
1075 test_set_prereq NOT_MINGW
1079 test -z "$NO_PERL" && test_set_prereq PERL
1080 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1082 # test whether the filesystem supports symbolic links
1083 ln -s x y
2>/dev
/null
&& test -h y
2>/dev
/null
&& test_set_prereq SYMLINKS
1086 # When the tests are run as root, permission tests will report that
1087 # things are writable when they shouldn't be.
1088 test -w / || test_set_prereq SANITY